<template>
  <section>
    <div class="grid grid-cols-3 gap-x-5">
      <TextInput label="Search" v-model="searchField" />
    </div>
    <div class="pb-5 flex justify-end">
      <button class="btn" @click="emitCreate">Add new</button>
    </div>
    <ClientOnly>
      <EasyDataTable
        v-if="items && headers"
        buttons-pagination
        show-index
        table-class-name="data-table"
        :search-value="searchField"
        :headers="headers"
        :items="items"
      >
        <template #item-actions="item">
          <div class="flex gap-x-5">
            <button
              class="btn-icon bg-blue-400 hover:bg-blue-500 transition text-white"
              @click="emitEvent('edit', item)"
            >
              <PenIcon />
            </button>
            <button
              class="btn-icon bg-red-400 hover:bg-red-500 transition text-white"
              @click="emitEvent('delete', item)"
            >
              <TrashIcon />
            </button>
          </div>
        </template>
      </EasyDataTable>
      <div v-if="!items">Invalid items props</div>
      <div v-if="!headers">Invalid headers props</div>
    </ClientOnly>
  </section>
</template>

<script setup lang="ts">
import TrashIcon from "@/assets/icons/trash.svg?component";
import PenIcon from "@/assets/icons/pen.svg?component";

import type { Header } from "vue3-easy-data-table";

defineProps<{ headers?: Header[]; items?: Array<any> | null }>();

const $emit = defineEmits(["delete", "edit", "create"]);

const searchField = ref("");

const emitEvent = (event: "delete" | "edit", item: any) => {
  $emit(event, item);
};

const emitCreate = () => {
  $emit("create");
};
</script>
